commit d54d2f07cf55f262267ac5bae4ff1549e315a0a6
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Fri Mar 16 11:43:09 2018 +0100

    Major overhaul (to version 1.1.0):
    - The bootloader toolchain now works with 32 bit device IDs (DiWheelDrive 1.1 = 0x01000101; PowerManagement 1.1 = 0x01010101; LightRing 1.0 = 0x017F0100).
      However, the system is still compatible to the old numbering scheme and legacy IDs for compatibility reasons.
      As a result, the new bootloader can be used with the old SerialBoot tool and vice versa.
    - In order to allow for 32 bit IDs, the CAN communication as modified.
      Packages which are larger than a single transmit are split into multiple CAN messages.
      An according handshaking mechanism (receiver acknowledges everey message) has been implemented.
      The device ID is not coded into the CAN message identifier anymore, but is transmitted as the first four bytes of the first CAN message of a XCP package transmission.
      However, the two lowermost bit of the CAN message identifier are now used as indicator flags for acknowledgment and subsequent transmission for simple filtering.
    - The bootloaders will not "double blink" the LED anymore, but indicate the XCP connection status.
    - The bootloader version has been incremented to 1.1.0.

diff --git a/Target/Source/gateway.c b/Target/Source/gateway.c
index 50e8edf..d74308e 100644
--- a/Target/Source/gateway.c
+++ b/Target/Source/gateway.c
@@ -23,11 +23,11 @@
 * You should have received a copy of the GNU General Public License along with OpenBLT.
 * If not, see <http://www.gnu.org/licenses/>.
 *
-* A special exception to the GPL is included to allow you to distribute a combined work 
-* that includes OpenBLT without being obliged to provide the source code for any 
+* A special exception to the GPL is included to allow you to distribute a combined work
+* that includes OpenBLT without being obliged to provide the source code for any
 * proprietary components. The exception text is included at the bottom of the license
 * file <license.html>.
-* 
+*
 * \endinternal
 ****************************************************************************************/
 
@@ -135,7 +135,7 @@ static void InitDebugData(void) {
 
 
 /************************************************************************************//**
-** \brief     Updates the gateway module by checking if new data was received 
+** \brief     Updates the gateway module by checking if new data was received
 **            and submitting the request to process newly received data.
 ** \return    none
 **
@@ -145,7 +145,7 @@ void GateTask(void)
   blt_int16s messageLength;
   /* make xcpCtoReqPacket static for runtime efficiency */
   static unsigned char xcpCtoReqPacket[BOOT_COM_RX_MAX_DATA];
- 
+
 #if (BOOT_GATE_CAN_ENABLE > 0)
   messageLength = (blt_int16s)CanReceivePacket(&xcpCtoReqPacket[0]);
   if (messageLength > 0)
@@ -265,7 +265,7 @@ void GateTransmitPacket(blt_int8u *data, blt_int16u len)
 blt_int16u GateGetActiveInterfaceMaxRxLen(void)
 {
   blt_int16u result;
-  
+
   /* filter on gateway interface identifier */
   switch (gateActiveInterface)
   {
@@ -284,18 +284,18 @@ blt_int16u GateGetActiveInterfaceMaxRxLen(void)
     case GATE_IF_NET:
       result = BOOT_COM_NET_RX_MAX_DATA;
       break;
-      
+
     default:
       result = BOOT_COM_RX_MAX_DATA;
       break;
   }
-  
+
   return result;
 } /*** end of GateGetActiveInterfaceMaxRxLen ***/
 
 
 /************************************************************************************//**
-** \brief     Obtains the maximum number of bytes that can be transmitted on the 
+** \brief     Obtains the maximum number of bytes that can be transmitted on the
 **            specified gateway interface.
 ** \return    Maximum number of bytes that can be received.
 **
@@ -303,7 +303,7 @@ blt_int16u GateGetActiveInterfaceMaxRxLen(void)
 blt_int16u GateGetActiveInterfaceMaxTxLen(void)
 {
   blt_int16u result;
-  
+
   /* filter on gateway interface identifier */
   switch (gateActiveInterface)
   {
@@ -322,12 +322,12 @@ blt_int16u GateGetActiveInterfaceMaxTxLen(void)
     case GATE_IF_NET:
       result = BOOT_COM_NET_TX_MAX_DATA;
       break;
-      
+
     default:
       result = BOOT_COM_TX_MAX_DATA;
       break;
   }
-  
+
   return result;
 } /*** end of GateGetActiveInterfaceMaxTxLen ***/
 
@@ -358,7 +358,7 @@ blt_bool GateIsConnected(void)
 ** \return    none.
 **
 ****************************************************************************************/
-void GateTransmitPacketDirect(blt_int8u *data, blt_int8u len, blt_int8u deviceID) {
+void GateTransmitPacketDirect(blt_int8u *data, blt_int8u len, blt_int32u deviceID) {
   forwarded = BLT_TRUE;
   CanTransmitPacket(data, len, deviceID);
   XcpPacketTransmitted();